"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterNot = filterNot;
const NoSuchElementException_1 = require("../../../exceptions/NoSuchElementException");
function filterNot(prev, predicate, func) {
    return __awaiter(this, void 0, void 0, function* () {
        if (prev.isError() || (yield predicate(prev.getValue())))
            return prev;
        try {
            if (func) {
                return prev.setError(yield func(prev.getValue()));
            }
            prev.setError(new NoSuchElementException_1.NoSuchElementException(`Predicate does not hold for ${prev.getValue()}`));
        }
        catch (err) {
            prev.setError(err);
        }
        return prev;
    });
}
